//-----------------------------------------------------------------------------
/*
 * Description: This file contains some globals definitions
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.12.2002
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-08-22 21:38:40 +0200 (Di, 22 Aug 2006) $
 *   $Revision: 1.2 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Tools_Globals_h__
#define __Ax_Tools_Globals_h__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Tools/Export.h>

//----- local -----------------------------------------------------------------

//-----------------------------------------------------------------------------
//     forward declarations
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//     define macros for users
//-----------------------------------------------------------------------------
#define AX_UNUSED_ARG(x) do { /* nothing */ } while (&x == 0);

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Tools
  //===========================================================================
  namespace Tools
  {
    //=========================================================================
    //     helper functions
    //=========================================================================
    template <typename TT> void DeleteNull(TT *&aPtr) { TT *aTmp = aPtr; aPtr = 0; delete aTmp; }
    template <typename TT> void FreeNull(TT *&aPtr)   { TT *aTmp = aPtr; aPtr = 0; free(aTmp);  }

    //=========================================================================
    //     tool functions
    //=========================================================================

    //---------------------------------------------------------------------
    //     getPID()
    //---------------------------------------------------------------------
    long AX_TOOLS_EXPORT getPID();

    //---------------------------------------------------------------------
    //     getTID()
    //---------------------------------------------------------------------
    long AX_TOOLS_EXPORT getTID();

  }; // namespace Tools
}; // namespace Ax

#endif // __Ax_Tools_Trace_h__
