//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Tools::InstanceCounter
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.12.2001
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2005-03-08 21:46:27 +0100 (Di, 08 Mär 2005) $
 *   $Revision: 1.2 $
 */
//-----------------------------------------------------------------------------
#ifndef __Ax_Tools_InstanceCounter_H__
#define __Ax_Tools_InstanceCounter_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
#include <string>

//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Tools/Export.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     defines
//=============================================================================

//=============================================================================
//     namespace Ax
//=============================================================================
namespace Ax
{
  //===========================================================================
  //     namespace Tools
  //===========================================================================
  namespace Tools
  {
    //=========================================================================
    //     class InstanceCounter
    //=========================================================================
    /** Count instances of named classes
     */
    class AX_TOOLS_EXPORT InstanceCounter
    {
      public:
        //---------------------------------------------------------------------
        //     InstanceCounter()
        //---------------------------------------------------------------------
        InstanceCounter(const InstanceCounter &);

        //---------------------------------------------------------------------
        //     InstanceCounter()
        //---------------------------------------------------------------------
        InstanceCounter(const std::string &theClassName);

        //---------------------------------------------------------------------
        //     ~InstanceCounter()
        //---------------------------------------------------------------------
        ~InstanceCounter();

        //---------------------------------------------------------------------
        //     operator=()
        //---------------------------------------------------------------------
        InstanceCounter &operator=(const InstanceCounter &);

        //---------------------------------------------------------------------
        //     dump()
        //---------------------------------------------------------------------
        static void dump(const std::string &theMsg /* = std::string("") */);

      private:
        //---------------------------------------------------------------------
        //     incRef()
        //---------------------------------------------------------------------
        void incRef(const std::string &theClassName);

        //---------------------------------------------------------------------
        //     decRef()
        //---------------------------------------------------------------------
        void decRef(const std::string &theClassName);

        //---------------------------------------------------------------------
        //     attributes
        //---------------------------------------------------------------------
        std::string myClassName;

    }; // class InstanceCounter

  }; // namespace Tools

}; // namespace Ax

#endif // __Ax_Tools_InstanceCounter_H__

