//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Mail::Mail
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.04.2006
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-04-17 17:19:12 +0200 (Mo, 17 Apr 2006) $
 *   $Revision: 204 $
 */
//-----------------------------------------------------------------------------

//=============================================================================
//     includes
//=============================================================================
//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- ICE -------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Tools/Trace.h>
// #include <Ax/Tools/TraceOn.h>

//----- vdr -------------------------------------------------------------------
//----- local plugin ----------------------------------------------------------
//----- locals ----------------------------------------------------------------
#include "Internal.h"
#include "MsgBody.h"

//=============================================================================
//     defines
//=============================================================================

//=============================================================================
//     using namespaces
//=============================================================================
using namespace std;

//=============================================================================
//     namespaces
//=============================================================================
namespace Ax
{
namespace Mail
{

//=============================================================================
//     class MsgBody
//=============================================================================

//-------------------------------------------------------------------------
//     MsgBody::MsgBody()
//-------------------------------------------------------------------------
MsgBody::MsgBody(BODY *theMsgBody)
       : myMsgBody(theMsgBody)
{
} // MsgBody::MsgBody()

//-------------------------------------------------------------------------
//     MsgBody::~MsgBody()
//-------------------------------------------------------------------------
MsgBody::~MsgBody()
{
} // MsgBody::~MsgBody()

//-------------------------------------------------------------------------
//     MsgBody::MsgBody()
//-------------------------------------------------------------------------
MsgBody::MsgBody(const MsgBody &that)
{
  myMsgBody = that.myMsgBody;
} // MsgBody::MsgBody()

//-------------------------------------------------------------------------
//     MsgBody::operator=()
//-------------------------------------------------------------------------
MsgBody &MsgBody::operator=(const MsgBody &that)
{
  if (this != &that)
  {
    myMsgBody = that.myMsgBody;
  } // if

  return *this;
} // MsgBody::operator=()

//-----------------------------------------------------------------------
//     MsgBody::dump()
//-----------------------------------------------------------------------
void MsgBody::dump() const
{
  Internal::dumpMsgBody(myMsgBody);
} // MsgBody::dumpMsgBody()

//=============================================================================
//     namespaces
//=============================================================================
} // namespace Mail
} // namespace Ax
