//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxMenuLogView
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   13.09.2005
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2005-09-12 19:09:16 +0200 (Mo, 12 Sep 2005) $
 *   $Revision: 1.19 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxMenuLogView_H__
#define __AxMenuLogView_H__

//=============================================================================
//     includes
//=============================================================================

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
#include <string>

//----- C ---------------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/osd.h>
#include <vdr/menuitems.h>

//----- AxLib -----------------------------------------------------------------
#include <Ax/Mail/Globals.h>
#include <Ax/Mail/LogHandler.h>
#include <Ax/VDR/MenuText.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================

//=============================================================================
//     class AxMenuLogView
//=============================================================================
/** Menu to display one mail.
 */
class AxMenuLogView : public Ax::VDR::MenuText
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef Ax::VDR::MenuText PARENT;
    typedef AxMenuLogView     MYSELF;

  protected:
    //-------------------------------------------------------------------------
    //     enums
    //-------------------------------------------------------------------------
    enum AxEAction
    {
      A_FIRST          = PARENT::A_LAST
    , A_CLEAR_LOG
    , A_LAST
    };

    //-------------------------------------------------------------------------
    //     enum AxPage
    //-------------------------------------------------------------------------
    enum AxPage
    {
      PAGE_JUMP
    , PAGE_MARK
    }; // enum AxPage

  public:
    //-------------------------------------------------------------------------
    //     AxMenuLogView()
    //-------------------------------------------------------------------------
    /** Constructor
     */
    AxMenuLogView(Ax::Mail::LogHandler &theLogHandler);

    //-------------------------------------------------------------------------
    //     ~AxMenuLogView()
    //-------------------------------------------------------------------------
    /** Destructor
     */
    virtual ~AxMenuLogView();

    //-------------------------------------------------------------------------
    //     processAction()
    //-------------------------------------------------------------------------
    virtual eOSState processAction(const Ax::VDR::Action &theAction, eOSState = osUnknown);

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    Ax::Mail::LogHandler &myLogHandler;

}; // class AxMenuLogView

#endif

