//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxMenuMailBoxView
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   17.11.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2005-10-16 20:54:30 +0200 (So, 16 Okt 2005) $
 *   $Revision: 1.13 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxMenuMailBoxView_H__
#define __AxMenuMailBoxView_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/osd.h>

//----- AxLib -----------------------------------------------------------------
#include <Ax/Mail/Globals.h>
#include <Ax/VDR/OsdMenu.h>

//----- local -----------------------------------------------------------------
#include "AxPluginSetup.h"

//----- other includes --------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================
class AxPluginMailBox;
namespace Ax
{
  namespace Mail
  {
    class MailBox;
  };
};

//=============================================================================
//     class AxMenuMailBoxView
//=============================================================================
/** Menu to select a mail account and to call the mail-list-view.
 */
class AxMenuMailBoxView : public Ax::VDR::OsdMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef Ax::VDR::OsdMenu  PARENT;
    typedef AxMenuMailBoxView MYSELF;

  protected:
    //-------------------------------------------------------------------------
    //     enums
    //-------------------------------------------------------------------------
    enum AxEAction
    {
      A_FIRST          = PARENT::A_LAST
    , A_OPEN_MAILBOX   = A_FIRST
    , A_REFRESH_CURRENT
    , A_REFRESH_ALL
    , A_SHOW_LOG
    , A_LAST
    };

  public:
    //-------------------------------------------------------------------------
    //     AxMenuMailBoxView()
    //-------------------------------------------------------------------------
    /** Constructor
     *
     *  VDR takes responsibility for the created items.
     */
    AxMenuMailBoxView(AxPluginMailBox *thePlugin);

    //-------------------------------------------------------------------------
    //     ~AxMenuMailBoxView()
    //-------------------------------------------------------------------------
    /** Destructor
     */
    virtual ~AxMenuMailBoxView();

    //-------------------------------------------------------------------------
    //     processAction()
    //-------------------------------------------------------------------------
    virtual eOSState processAction(const Ax::VDR::Action &theAction, eOSState = osUnknown);

    //-------------------------------------------------------------------------
    //     doOpenCurrentMailBox()
    //-------------------------------------------------------------------------
    eOSState doOpenCurrentMailBox();

    //-------------------------------------------------------------------------
    //     getCurrentMailBox()
    //-------------------------------------------------------------------------
    Ax::Mail::MailBox *getCurrentMailBox() const;

  protected:
    //-------------------------------------------------------------------------
    //     updateActions()
    //-------------------------------------------------------------------------
    void updateActions();

    //-------------------------------------------------------------------------
    //     actionCheckMailBoxes()
    //-------------------------------------------------------------------------
    void checkMailBoxes();

    //-------------------------------------------------------------------------
    //     informSubOSDClosed()
    //-------------------------------------------------------------------------
    virtual void informSubOSDClosed(const Ax::VDR::Action &theAction, eKeys theKey);

    //-------------------------------------------------------------------------
    //     informCurrentChanged()
    //-------------------------------------------------------------------------
    virtual void informCurrentChanged(int theOldCurrent);

  private:
    //-------------------------------------------------------------------------
    //     checkMailBox()
    //-------------------------------------------------------------------------
    void checkMailBox(int theIndex);

    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxPluginMailBox *myPlugin;

}; // class AxMenuMailBoxView

#endif

